package com.shanghaichengdi.ghjgitem.config;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import javax.annotation.Resource;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

@Configuration
public class WebMvcConfig implements WebMvcConfigurer {

  private final List<String> excludePathList = new ArrayList<>(
      Arrays.asList("/auth/**", "/login/**","/error/**"));
  @Resource
  private AuthenticationInterceptor authenticationInterceptor;
  @Resource
  private PermissionsVerifyInterceptor permissionsVerifyInterceptor;

  @Override
  public void addInterceptors(InterceptorRegistry registry) {
    registry.addInterceptor(authenticationInterceptor).addPathPatterns("/**")
        .excludePathPatterns(excludePathList);
    registry.addInterceptor(permissionsVerifyInterceptor).addPathPatterns("/**")
        .excludePathPatterns(excludePathList);
  }
}
