package com.shanghaichengdi.ghjgitem.controller;

import com.alibaba.fastjson.JSONObject;
import com.shanghaichengdi.ghjgitem.constant.Constants;
import com.shanghaichengdi.ghjgitem.constant.HttpStatus;
import com.shanghaichengdi.ghjgitem.domain.ReturnMsg;
import com.shanghaichengdi.ghjgitem.service.SysUserService;
import com.shanghaichengdi.ghjgitem.util.CommonTools;
import com.shanghaichengdi.ghjgitem.util.Encodes;
import com.shanghaichengdi.ghjgitem.vo.ObjectBodyVo;
import com.shanghaichengdi.ghjgitem.vo.SysUserVo;
import com.shanghaichengdi.ghjgitem.vo.request.SysUserReq;
import com.shanghaichengdi.ghjgitem.vo.response.ResultRes;
import java.nio.charset.StandardCharsets;
import java.util.List;
import javax.annotation.Resource;
import lombok.extern.slf4j.Slf4j;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@CrossOrigin
@RequestMapping("/user")
@Slf4j
public class SysUserController extends CommonController {

  @Resource
  private SysUserService sysUserService;

  @PostMapping("/info")
  public ReturnMsg getSysUserInfo(@RequestBody @Validated ObjectBodyVo vo) {
    if (!checkTokenKey(vo.getKey())) {
      return ReturnMsg.error(HttpStatus.BAD_REQUEST, "key值有误,请确认您输入的key值正确!");
    }
    String paramJsonData = new String(Encodes.aesDecrypt(
        Encodes.decodeBase64(vo.getData()),
        Constants.ENCODES_KEY.getBytes(),
        Constants.ENCODES_KEY.getBytes()), StandardCharsets.UTF_8);
    SysUserReq sysUserReq = JSONObject.parseObject(paramJsonData, SysUserReq.class);
    List<SysUserVo> sysUserVoList = sysUserService.selectUserInfo(sysUserReq);
    ResultRes resultRes = ResultRes.encapsulationResult(sysUserReq.getPageIndex(),
        sysUserReq.getPageSize(),
        CommonTools.getTotal(sysUserVoList), sysUserVoList);
    String jsonString = JSONObject.toJSONString(resultRes);
    String encodedData = Encodes.encodeBase64(
        Encodes.aesEncrypt(jsonString.getBytes(StandardCharsets.UTF_8),
            Constants.ENCODES_KEY.getBytes(),
            Constants.ENCODES_KEY.getBytes()));
    return ReturnMsg.success("获取成功", encodedData);
  }
}
