package com.shanghaichengdi.ghjgitem.service.impl;

import com.shanghaichengdi.ghjgitem.service.RedisService;
import java.util.concurrent.TimeUnit;
import javax.annotation.Resource;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

@Service
public class RedisServiceImpl implements RedisService {

  @Resource
  private RedisTemplate<String, Object> redisTemplate;


  @Override
  public boolean hasKey(String key) {
    return Boolean.TRUE.equals(redisTemplate.hasKey(key));
  }

  @Override
  public boolean hasKey(String folder, String key) {
    return Boolean.TRUE.equals(redisTemplate.hasKey(folder + key));
  }

  @Override
  public void setStringCache(String key, String value, Integer time, TimeUnit timeUnit) {
    redisTemplate.opsForValue().set(key, value, time, timeUnit);
  }

  @Override
  public void setStringCache(String folder, String key, String value, Integer time,
      TimeUnit timeUnit) {
    redisTemplate.opsForValue().set(folder + key, value, time, TimeUnit.MINUTES);
  }

  @Override
  public String getValue(String key) {
    return (String) redisTemplate.opsForValue().get(key);
  }

  @Override
  public String getValue(String folder, String key) {
    return (String) redisTemplate.opsForValue().get(folder + key);
  }
}
